﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using Telerik.Windows.Controls;

namespace TestTimeline
{
    public class TestTimelineViewModel : INotifyPropertyChanged
    {
        public TestTimelineViewModel()
        {
            InitTimeRange();
        }

        private void InitTimeRange()
        {
            StartDate = new DateTime(2012, 5, 20);
            EndDate = StartDate.AddDays(30);

            VisibleStart = StartDate.AddDays(6);
            VisibleEnd = StartDate.AddDays(10);

            SelectionStart = StartDate.AddDays(7);
            SelectionEnd = StartDate.AddDays(9);

            MinSelection = TimeSpan.FromDays(1);
            MaxSelection = TimeSpan.FromDays(15);
        }

        private DateTime _startDate;
        private DateTime _endDate;
        private DateTime _visibleStart;
        private DateTime _visibleEnd;
        private DateTime _selectionStart;
        private DateTime _selectionEnd;
        private TimeSpan _minSelection;
        private TimeSpan _maxSelection;

        public DateTime StartDate
        {
            get { return _startDate; }
            set { _startDate = value; OnPropertyChanged("StartDate"); }
        }

        public DateTime EndDate
        {
            get { return _endDate; }
            set { _endDate = value; OnPropertyChanged("EndDate"); }
        }

        public DateTime VisibleStart
        {
            get { return _visibleStart; }
            set { _visibleStart = value; OnPropertyChanged("VisibleStart"); }
        }

        public DateTime VisibleEnd
        {
            get { return _visibleEnd; }
            set { _visibleEnd = value; OnPropertyChanged("VisibleEnd"); }
        }

        public DateTime SelectionStart
        {
            get { return _selectionStart; }
            set { _selectionStart = value; OnPropertyChanged("SelectionStart"); }
        }

        public DateTime SelectionEnd
        {
            get { return _selectionEnd; }
            set { _selectionEnd = value; OnPropertyChanged("SelectionEnd"); }
        }

        public TimeSpan MinSelection
        {
            get { return _minSelection; }
            set { _minSelection = value; OnPropertyChanged("MinSelection"); }
        }

        public TimeSpan MaxSelection
        {
            get { return _maxSelection; }
            set { _maxSelection = value; OnPropertyChanged("MaxSelection"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string name)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(name));
            }
        }
    }
}
